#include <iostream>
#include <fstream>

using namespace std;

int n, m, p;
int s[ 55 ][ 55 ];

struct contestant
{
    bool c[ 12 ][ 12 ];
    int ck;
    int cs;
    int rowK, colK;
    int num;
}con[ 102 ];

bool cmp( contestant A, contestant B )
{
    return A.cs > B.cs;
}

struct triple
{
    int X, Y, maxS;
    triple( int a, int b, int m )
    {
        X = a;
        Y = b;
        maxS = m;
    }
};

struct answer
{
    int numb, R, C;
}ans[ 102 ], anss;

triple safety( int k )
{
    int max = 0, maxX = 0, maxY = 0;
    int sum;
    bool flag;
    
    for ( int i = 1; i <= n - con[ k ].rowK + 1; i++ )
    {
        for ( int j = 1; j <= m - con[ k ].colK + 1; j++ )
        {
            sum = 0;
            flag = 0;
            
            for ( int row = 1; row <= con[ k ].rowK; row++ )
            {
                for ( int col = 1; col <= con[ k ].colK; col++ )
                {
                    if ( con[ k ].c[ row ][ col ] ) 
                    {
                        if ( s[ i + row - 1 ][ j + col - 1 ] >= con[ k ].cs )
                        {
                            sum += s[ i + row - 1 ][ j + col - 1 ];
                        }
                        else
                        {
                            flag = 1;
                            sum = 0;
                            break;
                        }
                    }
                }
                if ( flag ) break;
            }
            if ( max < sum )
            {
                max = sum;
                maxX = i;
                maxY = j;
            }
        }
    }
       
    return triple( maxX, maxY, max );
}
int main()
{  
    fstream fo, fi;
    fi.open( "parash.in", ios::in );
    fi >> n >> m >> p;
    
    for ( int i = 1; i <= n; i++ )
    {
        for ( int j = 1; j <= m; j++ ) fi >> s[ i ][ j ];
    }     
    
    char pol;
    
    for ( int k = 1; k <= p; k++ )
    {
        fi >> con[ k ].rowK >> con[ k ].colK >> con[ k ].ck >> con[ k ].cs;
        con[ k ].num = k;
        
        for ( int i = 1; i <= con[ k ].rowK; i++ )
        {
            for ( int j = 1; j <= con[ k ].colK; j++ ) 
            {
                fi >> pol;
                con[ k ].c[ i ][ j ] = pol - '0';
            }
        }
    }
    
    fi.close();
    
    int br = 0;
    triple T( 0, 0, 0 );
    
    sort(con + 1, con + p + 1, cmp );
    
    /*cout << "-------------------------" << endl;
    for ( int k = 1; k <= p; k++ )
    {
        cout << con[ k ].num << " " << con[ k ].cs << endl;
        for ( int i = 1; i <= con[ k ].rowK; i++ )
        {
            for ( int j = 1; j <= con[ k ].colK; j++ ) cout << con[ k ].c[ i ][ j ] <<" ";
            cout << endl;
        }
        cout << "-------------------------" << endl;
    }*/
    fo.open("parash.out", ios::out );
    
    for ( int k = 1; k <= p; k++ )
    {
        T = safety( k );
        if ( T.maxS != 0 )
        {
            anss.numb = con[ k ].num;
            anss.R = T.X;
            anss.C = T.Y;
            ans[ br ] = anss;
             
            br++;
            for ( int i = T.X; i <= T.X + con[ k ].rowK - 1; i++ )
            {
                for ( int j = T.Y; j <= T.Y + con[ k ].colK - 1; j++ )
                {
                    s[ i ][ j ] /= con[ k ].ck;
                }
            }
            
        }
    }
    
    fo << br << endl;
    for ( int k = 0; k < br; k++ )
    {
        fo << ans[ k ].numb << " " << ans[ k ].R << " " << ans[ k ].C << endl;
    }
    fo.close();
    //system("pause");
    return 0;
}
